#include <iostream>
#include <string.h>
#include <vector>
using namespace std;

int main() {
	string s;
	cin >> s;
	vector<int> broj_ponavljanja(26, 0);

	for (int i = 0; i < s.size(); i++) {
		broj_ponavljanja[s[i] - 97]++;
	}

	string palindrom1(s);
	string palindrom2(s);
	
	for (int i = 0; i < 26; i++) {
		if (broj_ponavljanja[i] % 2 == 1) {
			palindrom1[palindrom1.size() / 2] = i + 'a';
			palindrom2[palindrom2.size() / 2] = i + 'a';
			broj_ponavljanja[i]--;
			break;
		}
	}
	
	vector<int> broj_pojavljivanja2 = broj_ponavljanja;

	// prvi palindrom

	for (int i = 0; i < s.size() / 2; i++) {
		if (broj_ponavljanja[s[i] - 'a'] > 1) {
			broj_ponavljanja[s[i] - 'a']--;
		}
		else {
			for (int j = 0; j < 26; j++) {
				if (broj_ponavljanja[j] > 1) {
					palindrom1[i] = j + 'a';
					broj_ponavljanja[j]--;

				}
			}
		}
	}

	int index = 0;

	for (int i = palindrom1.size() - 1; i >= palindrom1.size() / 2; i--) {
		palindrom1[i] = palindrom1[index];
		index++;
	}

	// drugi palindrom

	for (int i = s.size() - 1; i >= s.size() / 2; i--) {
		if (broj_pojavljivanja2[s[i] - 'a'] > 1) {
			broj_pojavljivanja2[s[i] - 'a']--;
		}
		else {
			for (int j = 0; j < 26; j++) {
				if (broj_pojavljivanja2[j] > 1) {
					palindrom2[i] = j + 'a';
					broj_pojavljivanja2[j]--;

				}
			}
		}
	}

	index = s.size() - 1;

	for (int i = 0; i < palindrom2.size() / 2; i++) {
		palindrom2[i] = palindrom2[index];
		index--;
	}

	int pocetak = -1, kraj = -1;

	for (int i = 0; i < s.size(); i++) {
		if (s[i] != palindrom1[i]) {
			pocetak = i;
			break;
		}
	}

	for (int i = s.size() - 1; i >= 0; i--) {
		if (s[i] != palindrom1[i]) {
			kraj = i;
			break;
		}
	}

	int razlika1 = kraj - pocetak + 1;

	pocetak = -1; 
	kraj = -1;

	for (int i = 0; i < s.size(); i++) {
		if (s[i] != palindrom2[i]) {
			pocetak = i;
			break;
		}
	}

	for (int i = s.size() - 1; i >= 0; i--) {
		if (s[i] != palindrom2[i]) {
			kraj = i;
			break;
		}
	}

	int razlika2 = kraj - pocetak + 1;

	cout << (razlika1 < razlika2 ? razlika1 : razlika2) << "\n";

	return 0;
}